// Author: Torsten.Leitner@email.de
// (c) 2006/2007



#include "InAndOut.h"

//namespace rhyno {

using namespace std;

int SaveXt(Complex *xt,	int Ntw, double Omegamax , double omega0 , double qmin , double qmax ,  char *stdfilename, int filenr)
{
	int jt;


     // class tArrayComplex2D_rt  	A    	 (Nr,Rmax,Ntw,Omegamax);
	class tArrayComplex2D_rt  xw (2,1,Ntw,Omegamax);
	
	for(jt=0;jt<Ntw;jt++) {
		xw.data[1][jt] = Complex(2*xt[jt].real(), 0 ); // 2*Realteil kopieren ...
	}
	
	xw.fft();
		
	ofstream out;
	char filename[120]; sprintf(filename,"%s_%i.xtw.dat",stdfilename,filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# t(j)[au] - d_nl(t(j))=2*Re{x(t)}(j) - w(j)/w0 - Abs{FFT[x(t)]}(j)"<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot x(t) vs. t[au] : $>  plot \""<< filename <<"\" u 1:2 w l \n" << endl;
   	out << "# Plot x(w) vs.  w/w0 : $>  plot [" <<qmin <<":"<< qmax <<"] \""<< filename <<"\" u 3:4 w l \n" << endl;
        out << "# " << endl;
        out << "# " << endl;
	
   	for (jt=0;jt<Ntw; jt++ ) {
 		out << xw.time[jt] <<" "
    		    << 2*xt[jt].real() <<" "
                    << xw.omega[jt]/(omega0*omega_SItoAU) <<" "
		    << abs(xw.data[1][jt]) 
                    << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	cout << "Done. " << endl;
	return 0;
}


// ********************************************************************************************** //












// ********************************************************************************************** //
int write_time_spatially_integrated_power(class tArrayComplex2D_rt *E, 
  		  		    int jtmin, int jtmax, int djt,
				    char *stdoutname, int filenr   )
{
        int ir,jt;
	int Ntw = E->Ntw;
	int Nr  = E->Nr;
	double dr  = E->dr*meter_AUtoSI;

	double pow;

	ofstream out;
	char filename[120];

	sprintf(filename, "%s_%i.t-int.dat", stdoutname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# t(j)[s] - IntPow(t) = Int_0^rmax{ 2*Pi*dr*r*Pow(r,t) }"<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot Pow(t) vs. t[s] : $>  plot \""<< filename <<"\" u 1:2 w l \n" << endl;
        out << "# " << endl;
        out << "# " << endl;

    

	for (jt=jtmin;jt<jtmax; jt+=djt) {
  	    pow =  0;
	    for(ir=1;ir<Nr;ir++ ) {
		// I_int = \int_0^rmax {|E|^2  r} 2 pi dr
		pow += E->intensity(ir,jt) * E->radiusSI(ir);
	    }
	    pow *= 2*PI*dr;
	    out << E->timeSI(jt)   <<" "<< pow <<" " << endl; 
	}

   	out.close();
   	cout << "Done. " << endl;
return 0;
}
// ********************************************************************************************** //

// ********************************************************************************************** //
int write_time_OnAxis(class tArrayComplex2D_rt *E, char *stdname, int filenr   )
{
	ofstream out;
	char filename[120];
	sprintf(filename, "%s_%i.t-onaxis.dat", stdname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;
 
  	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# t(j)[s] - Ereal(r=0,t) - Eimag(r=0,t) "<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot Ereal(r=0,t) vs. t[s] : $>  plot \""<< filename <<"\" u 1:2 w l \n" << endl;
   	out << "# Plot   Pow(r=0,t) vs. t[s] : $>  plot \""<< filename <<"\" u 1:(($2)**2 + ($3)**2 ) w l \n" << endl;
        out << "# " << endl;
        out << "# " << endl;

        int ir,jt;
	
	ir=0;
   	for (jt=0;jt<(E->Ntw); jt++) {
 			out << E->timeSI(jt)   <<" "
 			    << E->realSI(ir,jt) <<" "
 			    << E->imagSI(ir,jt) <<" "
 			    << endl;
   	}
   	out.close();
   	cout << "Done. " << endl;
return 0;
}
// ********************************************************************************************** //


// ********************************************************************************************** //
int write_time_2d(class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdname, int filenr   )
{
	ofstream out;
	char filename[120];
	sprintf(filename, "%s_%i.t-r.dat", stdname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

  	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# r(i)[m] - t(j)[s] - Ereal(r,t) - Eimag(r,t) "<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot Ereal(r=0,t) vs. t[s] : $>  plot \""<< filename <<"\" u 1:3 w l \n" << endl;
   	out << "# Plot   Pow(r=0,t) vs. t[s] : $>  plot \""<< filename <<"\" u 1:(($3)**2 + ($4)**2 ) w l \n" << endl;
   	out << "# Plot    r-t-Pow-Surface    : $>  splot \""<< filename <<"\" u 1:2:(($3)**2 + ($4)**2 ) w l" << endl;
        out << "# " << endl;
        out << "# " << endl;

        int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			out << E->radiusSI(ir) <<" "
 			    << E->timeSI(jt)   <<" "
 			    << E->realSI(ir,jt) <<" "
 			    << E->imagSI(ir,jt) <<" "
			    << endl; 
   		}   out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	out.close();
   	cout << "Done. " << endl;
return 0;
}
// ********************************************************************************************** //

















// ********************************************************************************************** //

int write_omegaOverOmega0_spatially_integrated(class tArrayComplex2D_rt *E , 
						double omega0, double qmin, double qmax,
						char *stdname,int filenr	)
{
	int ir,jt;
	int Ntw = E->Ntw;
	int Nr  = E->Nr;
	double dr  = E->dr*meter_AUtoSI;

	double pow;

	ofstream out;
	char filename[120];

	sprintf(filename, "%s_%i.w0-int.dat", stdname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# q=w(j)/w0 - IntPow(q) = Int_0^rmax{ 2*Pi*dr*r*Pow(r,t) }"<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot Pow(q) vs. q : $>  plot \""<< filename <<"\" u 1:2 w l \n" << endl;
//   	out << "# Plot Pow(q) vs. q : $>  plot [" <<qmin <<":"<< qmax <<"] \""<< filename <<"\" u 3:4 w l \n" << endl;
        out << "# " << endl;
        out << "# " << endl;

    
	double q;
	int jtmax=int(E->Ntw *0.5); // speichere nur positive frequenzen ...

	for (jt=0;jt<=jtmax; jt++) { 
		q=E->omegaSI(jt)/omega0;
		if ( (q>qmin) && (q<qmax) ) {
		    pow=0;
		    for(ir=1;ir<Nr;ir++ ) {
			// I_int = \int_0^rmax {|E|^2  r} 2 pi dr
			pow += E->intensity(ir,jt) * E->radiusSI(ir);
		    }
  	            pow *= 2*PI*dr;
		    out << q  <<" "<< pow <<" " << endl; 
		}
	}

   	out.close();
   	cout << "Done. " << endl;	
	return 0;
}
// ********************************************************************************************** //


// ********************************************************************************************** //

int write_omegaOverOmega0_onAxis(class tArrayComplex2D_rt *E , 
					double omega0, double qmin, double qmax,
					char *stdname,int filenr	)
{
	int ir,jt;
	int Ntw = E->Ntw;
	int Nr  = E->Nr;
	double dr  = E->dr*meter_AUtoSI;

	double pow;

	ofstream out;
	char filename[120];

	sprintf(filename, "%s_%i.w0-onaxis.dat", stdname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# q=w(j)/w0 - Pow(r=0,q) - - phi(r=0,q) "<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot   Pow vs. q  : $>  plot \""<< filename <<"\" u 1:2 w l \n" << endl;
   	out << "# Plot   phi vs. q  : $>  plot \""<< filename <<"\" u 1:3 w l \n" << endl;
        out << "# " << endl;
        out << "# " << endl;

    
	double q;
	int jtmax=int(E->Ntw *0.5); // speichere nur positive frequenzen ...
	
	ir=0; // onAxis
	for (jt=0;jt<=jtmax; jt++) { 
		q=E->omegaSI(jt)/omega0;
		if ( (q>qmin) && (q<qmax) ) {
		  out << q  <<" "<< E->intensity(ir,jt) <<" "<< arg(E->data[ir][jt]) << endl; 
		}
	}

   	out.close();
   	cout << "Done. " << endl;	
	return 0;
}
// ********************************************************************************************** //




// ********************************************************************************************** //
int write_omegaOverOmega0_2d(class tArrayComplex2D_rt *E, double omega0 ,
				  		double qmin , double qmax ,
				  		int irmin, int irmax, int dir, 
				  		char *stdname, int filenr   )
{
	ofstream out;
	char filename[120];
	sprintf(filename, "%s_%i.w0-r.dat", stdname, filenr);
	out.open(filename, ios::out|ios::trunc);

	cout << "Saving "<< filename << " ... " ;

  	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
        out << "# columns :" << endl;
 	out << "# r(i)[m] - q=w(j)/w0 - Pow(r,q) - phi(r,q) "<< endl; 
        out << "# " << endl;
        out << "# gnuplot commands to directly plot data :" << endl;
   	out << "# Plot   Pow vs. r[m]     : $>  plot \""<< filename <<"\" u 1:3 w l \n" << endl;
   	out << "# Plot   Pow vs. q        : $>  plot \""<< filename <<"\" u 2:3 w l \n" << endl;
   	out << "# Plot    r-q-Pow-Surface : $>  splot \""<< filename <<"\" u 1:2:3 w l" << endl;
   	out << "# Plot    r-q-phi-Surface : $>  splot \""<< filename <<"\" u 1:2:4 w l" << endl;
        out << "# " << endl;
        out << "# " << endl;

        int ir,jt;
	double q;
	int jtmax=int(E->Ntw *0.5); // speichere nur positive frequenzen ...

	for (jt=0;jt<=jtmax; jt++) { 
		q=E->omegaSI(jt)/omega0;
		if ( (q>qmin) && (q<qmax) ) {
   		  for (ir=irmin;ir<irmax;ir+=dir) { 
		    out << E->radiusSI(ir) <<" "
			<< q  <<" "
			<< E->intensity(ir,jt) <<" "
			<< arg(E->data[ir][jt])
			<< endl;  
   		  }   out << endl; // empty line after every t/w-slice for better data handling in gnuplot
                }
   	}
   	out.close();
   	cout << "Done. " << endl;
return 0;
}
// ********************************************************************************************** //























// ********************************************************************************************** //

int SaveOneLineOnly(class tArrayComplex2D_rt *H, int ir, char *stdfilename, double omega0 , int filenr)
{
	int jt;
	int Ntw = H->Ntw;
//	int Nr  = H->Nr;
//	double dr  = H->dr;
//	double Rmax= H->rmax;
//	double Omegamax = H->wmax;
	
	ofstream out;
	char filename[120]; sprintf(filename,"%s_%i.1l.dat",stdfilename,filenr);
	out.open(filename, ios::out|ios::trunc);
	
	cout << "Saving "<< filename << " ... " ;
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> plot \""<< filename <<"\" w l \n" << endl;
   	
   	for (jt=0;jt<Ntw; jt++ ) {
 			out << H->omega[jt]/omega0 <<" "<< H->data[ir][jt] << endl; 
   	}   
   	out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	out.close();
   	
   	cout << "Done. " << endl;
	
	return 0;
}
// ********************************************************************************************** //


















// ********************************************************************************************** //
int write_omega_2d(class tArrayComplex2D_rt *E, 
				  		int irmin, int irmax, int dir, 
				  		int jtmin, int jtmax, int djt,
				  		char *stdname, int filenr   )
{

	if (jtmax>int(0.5*E->Ntw)) {jtmax=int(0.5*E->Ntw);}	
	ofstream out;
	char name[120];
	sprintf(name, "%s_%i.w.dat", stdname, filenr);
	out.open(name, ios::out|ios::trunc);
//   	cout << "Writing data to \"" << name <<"\" ..."<<endl;
   	out << "# gnuplot conform data-file produced by "<< PROGRAM_NAME << endl;
   	out << "# Try:  gnuplot> splot \""<< name <<"\" w l \n" << endl;
    int ir,jt;
   	for (ir=irmin;ir<irmax;ir+=dir) { 
   		for (jt=jtmin;jt<jtmax; jt+=djt) {
 			out << E->radiusSI(ir) <<" "
 					<< E->omegaSI(jt)  <<" "
 					<< E->intensity(ir,jt) <<" "
 					<< E->realSI(ir,jt) <<" "
 					<< E->imagSI(ir,jt) <<" "
 					<< endl; 
   		}   out << endl; // empty line after every t/w-slice for better data handling in gnuplot
   	}
   	out.close();
return 0;
}
// ********************************************************************************************** //


//} // end of namespace rhyno


