// Author: Torsten.Leitner@email.de
// (c) 2006/2007




#include "InitFundamentalLaser.h"



// % ***************************************************************************
int InitFundamentalLaser_GaussianProfile_tSpace_AtomicUnits(class  tArrayComplex2D_rt *Laser, 
												struct InputParameter     *in     )   
{
//*
	if ( (Laser->dr==0)|(Laser->dw==0)|(Laser->dt==0) ) { cout << "Laser not correctly initialized ..."<<endl; return 1; }

cout << "Initializing the Laser ..."<<endl;
	double E0	= VperM_SItoAU * in->E0;
//	       Laser->radius[ir] is in au
	double waist0	= meter_SItoAU * in->waist0;
	double zfocus	= meter_SItoAU * in->zfocus;
	double lam	= meter_SItoAU * in->lam;
//	       Laser->time[jt]   is in au
	double lifetime = time_SItoAU * in->lifetime;
	
	double w0	= omega_SItoAU * in->omega0 ;	
 /*
cout <<"E0 "<< E0 <<" waist "<< waist0 <<" zf "<< zfocus  <<" lam "<< lam  <<" lifetime "<< lifetime << " w0 "<< w0 <<endl;
cout <<"r[Nr/2] " << Laser->radius[int(0.5*Laser->Nr)] <<"  t[Nr/4] " << Laser->time[int(0.25*Laser->Ntw)] << endl;
cout <<"rmax " << Laser->rmax << " tmax "<< Laser->tmax << " wmax "<< Laser->wmax << endl;
cout << endl;
// */
	for (int ir=0;ir<Laser->Nr;ir++) {      //% Calc Laser(t)
  		for (int jt=0;jt<Laser->Ntw;jt++) { 
	 		Laser->data[ir][jt] =  gauss2d_radial(E0,Laser->radius[ir],waist0,zfocus,lam) 
	 						    *  gauss_tdomain (Laser->time[jt], w0 ,lifetime) ;
  		}
	}
	return 0;
}
// % ***************************************************************************



// % ***************************************************************************
Complex gauss2d_radial(double E0,double r,double waist0, double z, double xlam)
{
	double tmp = (PI*waist0*waist0)/xlam;
	Complex q0( 0 , tmp ); //	z0=(PI*w0*w0)/xlam;//	! rayleigh length
	Complex qz( z , tmp ); 
	return E0 * (q0/qz) * exp( -Complex(0,1)*(2*PI/xlam)*(z+(0.5*r*r/qz)) );
//	return E0 * ( Complex(0,tmp) / Complex(z,tmp) ) * exp( -Complex(0,1)*(2*PI/xlam)*(z+(0.5*r*r/Complex(z,tmp))) );
}	
// % ***************************************************************************


// % ***************************************************************************
Complex gauss_tdomain(double t,double w0, double lifetime)
{
	return exp(- pow( (t/lifetime) , 2) ) * exp( Complex(0,1) * w0 * t);
}	
// % ***************************************************************************


// % ***************************************************************************
Complex gauss_wdomain(double w,double w0, double lifetime)
{					//				Realpart	, Imag.
	return Complex(2 * pow(PI,1.5) * exp( -pow( ((w-w0)*lifetime) ,2 ) ) , 0 );
}	
// % ***************************************************************************

// % ***************************************************************************
int InitFundamentalLaser_GaussianProfile_tSpace(
		class tArrayComplex2D_rt *Laser, double E0, double xlam, 
		int Nr , double *radius, double waist0, double zfocus, 
	 	int Ntw, double *time  , double lifetime   
	)
{
	cout << " Start init field ..." << endl;
	for (int ir=0;ir<Nr;ir++) {      //% Calc Laser(t)
  		for (int jt=0;jt<Ntw;jt++) { 
	 		Laser->data[ir][jt] =  gauss2d_radial(E0,radius[ir],waist0,zfocus,xlam) 
	 						    *  gauss_tdomain (time[jt], (2*PI*CLIGHT/xlam),0.5*lifetime) ;
  		}
	}
	return 0;
}
// % ***************************************************************************

// % ***************************************************************************
int InitFundamentalLaser_GaussianProfile_tSpace(class  tArrayComplex2D_rt *Laser, 
												struct InputParameter     *in     )   
{
//*
	if ( (Laser->dr==0)|(Laser->dw==0)|(Laser->dt==0) ) { cout << "Laser not correctly initialized ..."<<endl; return 1; }
	
//	cout << " Start init field ..." << endl;
	for (int ir=0;ir<Laser->Nr;ir++) {      //% Calc Laser(t)
  		for (int jt=0;jt<Laser->Ntw;jt++) { 
	 		Laser->data[ir][jt] =  gauss2d_radial(in->E0,Laser->radius[ir],in->waist0,in->zfocus,in->lam) 
	 						    *  gauss_tdomain (Laser->time[jt], (2*PI*CLIGHT/in->lam),0.5*in->lifetime) ;
  		}
	}
//*/////	
	return 0;
}
// % ***************************************************************************
//
//// % ***************************************************************************
//int InitFundamentalLaser_GaussianProfile_tSpace(class  tArrayComplex3D_xyt *Laser, 
//												struct InputParameter     *in     )   
//{
////*
//	if ( (Laser->dr==0)|(Laser->dw==0)|(Laser->dt==0) ) { cout << "Laser not correctly initialized ..."<<endl; return 1; }
//	
////	cout << " Start init field ..." << endl;
//	for (int ir=0;ir<Laser->Nr;ir++) {      //% Calc Laser(t)
//  		for (int jt=0;jt<Laser->Ntw;jt++) { 
//	 		Laser->data[ir][jt] =  gauss2d_radial(in->E0,Laser->radius[ir],in->waist0,in->zfocus,in->lam) 
//	 						    *  gauss_tdomain (Laser->time[jt], (2*PI*CLIGHT/in->lam),in->lifetime) ;
//  		}
//	}
////*/////	
//	return 0;
//}
//// % ***************************************************************************

