// Author: Torsten.Leitner@email.de
// (c) 2006/2007


#ifndef OPTIONS_H_
#define OPTIONS_H_


#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <math.h>
#include <complex>
#include <vector>
#include <sstream>

#include "Constants.h"
#include "Definitions.h"
#include "tools.h"  //enthaelt: #include "AnyOption.h"
#include "AnyOption.h"


struct InputParameter {
	
				//	flags
	bool istimestamp;
	
				//	files
	string outfile;
	string optfile;
	string title;
	
	int nPics;  // Number of output-mesh.dat-files
		
				// Propagation Parameters
	int nsteps;	// Steps between Source-Evaluations
	int nruns;	// Number  of    Source-Evaluations between 2 mesh.dat s
	double dz;	// Propagation stepsize  ( dz = c*dt )
	
// ==> TOTAL-No. of Propagation Steps =  nPics*nruns*nsteps
// ==> TOTAL-No. of SourceEvaluations =  nPics*nruns
// ==> TOTAL-No. of mesh.dat - files  =  nPics  
	
	int Nr; 	// Spatial Grid
	double dr,rmax;
		
	int	   Ntw;	// Time/Omega Grid
	double dt,tmin,tmax;
	double dw,wmin,wmax;		
		
	int Ntw1;	// Fundamental Time/Omega Grid
	double dt1,t1min,t1max;
	double dw1,w1min,w1max;
	
	int Ntwh;	// Harmonic Time/Omega Grid
	double dth,thmin,thmax;
	double dwh,whmin,whmax;

// The fundamental Laser		
	double Intensity;   // [W/cm2]
	double E0;			// [V/m]
	double Up;			// [J]
	double lam;			// [m]
	double omega0;		// [rad/s]
	double lifetime;	// [s]
	double fwhm;		// [s] : fwhm = 2*sqrt(ln(2)) * lifetime
	double waist0;		// [m]
	double zfocus;		// [m]
// The gas	
	int    ZAtom;		// [1]
	double Ip;			// [eV]	
	double Pressure;	// [mbar]
	double Temperature;	// [Kelvin]
	double AtomDensity; // [1/m3]
	
	
	double qcut;
	double qmax;
	double qvalid;
	double qmin;

// Simulation Params.
	double Q;//	 = 200;		// Max.Sampled frequency in multiples of omega0
	double L ;//	 = 6;		// Min. Size of time window in measures of laser lifetime tau
	double ppoc ;//  = 2 * in->Q;   // Points per optical cycle
	double Noc;//	 = 4;		// Number of optical cycles to be integrated	
	int    Npoints2integrateXt; // = int( inpar.Noc * inpar.ppoc +1 ); // Number of points to integrate nl dip.moment
	double threshold; // MININTENSITY_TO_CALC_DIP; // 1e10 [W/cm2]


//// OLD   ///////

	int vecpot_number_of_interpolation_points;
	double Tmin; 		// Min.Time in opt.Cycles of the fundamental (2pi each)
	double abs_omega_error; // Absolute error of the frequency spectrum in measures of the fundamental.
// Params for dipolemoment integration
	double taumin; // Max.Time in opt.Cycles of the fundamental (2pi each)
	double taumax;
	double dtau;
};



int SetStandardInputParameters(InputParameter *in);

int handle_all_options(int argc, char **argv, InputParameter *inpar);



#endif /*OPTIONS_H_*/

