//
// Author: Torsten.Leitner@email.de
// (c) 2006/2007
//

#include "evolve.h"

using namespace std;


// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*   With    class tArrayComplex2D_rt
int evolve2d_fullAU(int nsteps, double dzAU, class tArrayComplex2D_rt *u, class tArrayComplex2D_rt *source)
{ 	
//
 	int k,ir,jt;
	int   Nr  = u->Nr;
	int   Ntw = u->Ntw;
//	double dr = u->dr;
	double h2 = (u->dr)*(u->dr);
//
	Complex alpha[Nr-1],beta[Nr-1],gamma[Nr-1],b[Nr-1];
	Complex D, lam, shortermmemory;
//
	Complex CmplxOne(1,0);
//
//	u->data[Nr-1]=0;
//
for (k=0;k<nsteps;k++) {  // Loop over nsteps with the same Source-Term
//	
	for (jt=1;jt<Ntw-1;jt++) {  // Loop over all w/t-Slices ...
//    
 		D=Complex(0,-0.5*CLIGHT_AU/u->omega[jt]);  	// Diffusion Const depending on omega(jt)
//
		lam = D * dzAU / h2;
//
		// This loop applies the new RightHandSide (rhs) b  and
		//	 the non-zero matrixelements: alpha[j],beta[j],gamma[j]
		alpha[0]  =  0 ; // alpha[0] is not existent and not used in the latter ...
		beta [0]  = CmplxOne + 4.0*lam ;
		gamma[0]  = - 4.0 *lam ;
		b    [0]  = ( CmplxOne - 4.0*lam ) * u->data[0][jt]   + 4.0*lam * u->data[1][jt]  - D*dzAU*source->data[0][jt];
//
		for (ir=1;ir<Nr-1;ir++)
		{  	
			alpha[ir]  =  - 0.5*( 1 - ( 1/(2*ir) ) )*lam   ;
			beta [ir]  = CmplxOne + lam ;
			gamma[ir]  =  - 0.5*( 1 + ( 1/(2*ir) ) )*lam ;
			b    [ir]  = ( CmplxOne - lam ) * u->data[ir][jt]   
				    + 0.5*(  Complex((1+(1/(2*ir))),0) * u->data[ir+1][jt]  
					        +Complex((1-(1/(2*ir))),0) * u->data[ir-1][jt] ) * lam  - D*dzAU*source->data[ir][jt];
		} 
//
		// Forward Recursion to get rid off all Elements lower than the diagonal...
		for (ir=1;ir<Nr-1;ir++)
		{ 
			shortermmemory = ( alpha[ir]/beta[ir-1] ) ;
//			alpha[ir] = alpha[ir] - ( alpha[ir]/beta[ir-1] ) * beta[ir-1] ;//  = 0
			beta[ir]  = beta[ir]  - shortermmemory * gamma[ir-1];
//			gamma[ir] = gamma[ir] - ( alpha[ir]/beta[ir-1] ) * 0 =  gamma[ir] ;
			b[ir] 	  = b[ir]     - shortermmemory * b[ir-1];		  
		}
//		
		// Backward Recursion ...
		u->data[Nr-1][jt] =    0;
	        u->data[Nr-2][jt] =    b[Nr-2] / beta[Nr-2];
		for (ir=Nr-3;ir>=0;ir--){  u->data[ir][jt]    = ( b[ir] - gamma[ir]*u->data[ir+1][jt] ) / beta[ir]; }
//
 	} // END of t/w-slices-loop
} // END of nsteps-loop 
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*/



// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*   With    class tArrayComplex2D_rt
int evolve2d(int nsteps, double dz, class tArrayComplex2D_rt *u, class tArrayComplex2D_rt *source)
{ 	
//
 	int k,ir,jt;
	int   Nr  = u->Nr;
	int   Ntw = u->Ntw;
//	double dr = u->dr;
	double h2 = (u->dr)*(u->dr);
//
	Complex alpha[Nr-1],beta[Nr-1],gamma[Nr-1],b[Nr-1];
	Complex D, lam, shortermmemory;
//
	Complex CmplxOne(1,0);
//
//	u->data[Nr-1]=0;
//
for (k=0;k<nsteps;k++) {  // Loop over nsteps with the same Source-Term
//	
	for (jt=1;jt<Ntw-1;jt++) {  // Loop over all w/t-Slices ...
//    
 		D=Complex(0,-0.5*CLIGHT/u->omega[jt]);  	// Diffusion Const depending on omega(jt)
//
		lam = D * dz / h2;
//
		// This loop applies the new RightHandSide (rhs) b  and
		//	 the non-zero matrixelements: alpha[j],beta[j],gamma[j]
		alpha[0]  =  0 ; // alpha[0] is not existent and not used in the latter ...
		beta [0]  = CmplxOne + 4.0*lam ;
		gamma[0]  = - 4.0 *lam ;
		b    [0]  = ( CmplxOne - 4.0*lam ) * u->data[0][jt]   + 4.0*lam * u->data[1][jt]  - D*dz*source->data[0][jt];
//
		for (ir=1;ir<Nr-1;ir++)
		{  	
			alpha[ir]  =  - 0.5*( 1 - ( 1/(2*ir) ) )*lam   ;
			beta [ir]  = CmplxOne + lam ;
			gamma[ir]  =  - 0.5*( 1 + ( 1/(2*ir) ) )*lam ;
			b    [ir]  = ( CmplxOne - lam ) * u->data[ir][jt]   
				    + 0.5*(  Complex((1+(1/(2*ir))),0) * u->data[ir+1][jt]  
					        +Complex((1-(1/(2*ir))),0) * u->data[ir-1][jt] ) * lam  - D*dz*source->data[ir][jt];
		} 
//
		// Forward Recursion to get rid off all Elements lower than the diagonal...
		for (ir=1;ir<Nr-1;ir++)
		{ 
			shortermmemory = ( alpha[ir]/beta[ir-1] ) ;
//			alpha[ir] = alpha[ir] - ( alpha[ir]/beta[ir-1] ) * beta[ir-1] ;//  = 0
			beta[ir]  = beta[ir]  - shortermmemory * gamma[ir-1];
//			gamma[ir] = gamma[ir] - ( alpha[ir]/beta[ir-1] ) * 0 =  gamma[ir] ;
			b[ir] 	  = b[ir]     - shortermmemory * b[ir-1];		  
		}
//		
		// Backward Recursion ...
		u->data[Nr-1][jt] =    0;
	        u->data[Nr-2][jt] =    b[Nr-2] / beta[Nr-2];
		for (ir=Nr-3;ir>=0;ir--){  u->data[ir][jt]    = ( b[ir] - gamma[ir]*u->data[ir+1][jt] ) / beta[ir]; }
//
 	} // END of t/w-slices-loop
} // END of nsteps-loop 
 	return 0;
}
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
// ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//*/




